#define TITLE "xmlrpcs Ver 02 by SaTa."

#include <winsock2.h>
#include <stdio.h>
#include <string.h>


int mi_urlsplit(char *in,char *url_host,char *url_file,int len);
int file_load(char *fn,char *buff,int len);

int main( int argv, char *argc[])
{

	char hostname[1024]="127.0.0.1";
	char  url[1024]="http://blog.goo.ne.jp/XMLRPC";
	int  port=80;
	char path[1024]="/";
	char data[4096];
	char xmldata[1024];

	int xmlsize;
	char xmlfn[1024];

	WSADATA wsadata;
	WORD wversion = MAKEWORD( 2, 0);
	SOCKET s;
	struct sockaddr_in client;
	struct hostent *servhost;
	int nError;


	if(argv<=1)
	{

		printf("%s",TITLE "\n"
		"\targ1 xml_file\n"
		"\targ2 URL\n"
		);
		return 0;
	}
	strncpy(xmlfn,argc[1],1023);
	if(argv>2)
	{
	strncpy(url,argc[2],1023);
	}
	printf("URL=%s\n",url);
	mi_urlsplit(url,hostname,path,1023);
	printf("host=%s\n",hostname);
	printf("path=%s\n",path);
	printf("xml_file=%s\n",xmlfn);

	xmlsize=file_load(xmlfn,xmldata,1023);
	if(xmlsize<1)
	{
		return -1;
	}
	

	//Winsock
	nError = WSAStartup( wversion, &wsadata);
	if( nError) {
		fprintf( stderr, "WSAStartup error\n");
		return -1;
	}
	//Winsock̃o[WmF
	if( wversion != wsadata.wVersion) {
		fprintf( stderr, "Winsock version error\n");
		return -1;
	}
	//\Pbg쐬
	s = socket( AF_INET, SOCK_STREAM, 0);
	if( s == 0) {
		fprintf( stderr, "Socket open error\n");
		return -1;
	}




	//eݒ
	memset( &client, '\0', sizeof( client));
	client.sin_family = AF_INET;
	
	//	zXgIPwł邩H
	if((client.sin_addr.s_addr=inet_addr( hostname ))==-1)
	{	// IPȊO
	  servhost=gethostbyname(hostname);
	  if(servhost==NULL)
	  {	//	Os
		fprintf( stderr, "bad hostname:%s\n",hostname);
		return -1;
	  }
	  else
	  {	//	O
		memcpy((char *)&client.sin_addr.s_addr,servhost->h_addr,servhost->h_length);
	  }
	}

	client.sin_port = htons( port );
	//ڑ
	printf( "Connect...");

	if( connect( s, (struct sockaddr *)&client, sizeof( client)) < 0) {
		fprintf( stderr, "Connect error\n");
		return -1;
	}
	printf( "...OK\n");
	//f[^𑗐M



	sprintf(data,"POST %s HTTP/1.0\r\n\
Host: %s\r\n\
User-Agent: xmlrpcs_win32/1.0\r\n\
Content-Length: %d\r\n\
\r\n\
%s\r\n\r\n",path,hostname,xmlsize,xmldata);

	
	if( send( s, data, strlen( data), 0) < 0) {
		fprintf( stderr, "Send error\n");
		return -1;
	}

	printf( "send dataF");
	printf("%s",data);


	//f[^M

	nError = recv( s, data, sizeof( data), 0);
	if( nError <= 0) {
		fprintf( stderr, "Recv error :%d\n",nError);
		return -1;
	}
	data[nError] = '\0';
	printf( "recv sizeF%d\n", nError);

	printf( "recv dataF%s", data);
	
	for(;;)
	{
		nError = recv( s, data, sizeof( data), 0);
		if( nError <= 0) {
			break;
		}
		data[nError] = '\0';
		printf( "%s", data);
	}

		if( nError < 0) {
			fprintf( stderr, "Recv error :%d\n",nError);
		}


	//\Pbg
	closesocket( s);
	//Winsock㏈
	WSACleanup();

	return 0;
}







int mi_urlsplit(char *in,char *url_host,char *url_file,int len)
{
	int i;
	int ret=0;
	char *p,*q;
	
	//	http:// 
	if(strlen(in)<=3)
	{
		strncpy(url_host,"",len);
		strncpy(url_file,in,len);
		return 2;
	}
	q=strstr(in,"file:///");
	if(q!=NULL)
	{
		q+=8;
		ret=2;
	}
	else
	{
		q=in;
	}

	p=strstr(in,"http://");
	if(p!=NULL)
	{
		p+=7;
		ret=1;
	}
	else
	{
		p=in;
	}
	
	if(ret==0)	//t@CpX̌ F0: `
	{
		if(in[3]==':')
		{
		ret=2;
		strncpy(url_host,"",len);
		strncpy(url_file,in,len);
			for(i=0;url_file[i]!='\0';i++)
			{
				switch(url_file[i])
				{
					case '\"':
					case ' ':
					case '\t':
					case '\n':
					case '\r':
					case '>':
					case '#':
						url_file[i]='\0';
						url_file[i+1]='\0';
						break;

				}
			}
		return ret;
		}
	}

	if(ret<=1)
	{
		ret=1;
			for(i=0;i<len;i++)
			{
				if( p[i] == '/')
				{
					
					strncpy(url_file,&p[i],len);
					p[i] = '\0';
					strncpy(url_host,&p[0],len);
					break;
				}
			}
			if(i==len)
			{
				// pXȂ "/"pXƂ݂Ȃ
				{
					strncpy(url_file,"/",len);
					strncpy(url_host,&p[0],len);
					for(i=0;url_host[i]!='\0';i++)
					{
						switch(url_host[i])
						{
							case '\"':
							case ' ':
							case '\t':
							case '\n':
							case '\r':
							case '>':
							case '#':
								url_host[i]='\0';
								url_host[i+1]='\0';
								break;
						}
					}
				}
			}

			for(i=0;url_file[i]!='\0';i++)
			{
				switch(url_file[i])
				{
					case '\"':
					case ' ':
					case '\t':
					case '\n':
					case '\r':
					case '>':
					case '#':
						url_file[i]='\0';
						url_file[i+1]='\0';
						break;
				}
			}
		return ret;
	}

	if(ret==2)
	{
		strncpy(url_host,"",len);
		strncpy(url_file,&q[0],len);
			for(i=0;url_file[i]!='\0';i++)
			{
				switch(url_file[i])
				{
					case '\"':
					case ' ':
					case '\t':
					case '\n':
					case '\r':
					case '>':
					case '#':
						url_file[i]='\0';
						url_file[i+1]='\0';
						break;

				}
			}
		return ret;
	}
		return -1;
}



int file_load(char *fn,char *buff,int len)
{
	FILE *fp;
	int i;
	fp = fopen(fn, "rb");
	if(fp==NULL)
	{
		buff[0]=0;
		printf("file open err:'%s'\n",fn);
		return -1;
	}
	i=fread(buff,1,len,fp);
	fclose(fp);
	if(i>0)
	{
		buff[i]=0;
		return i;
	}
	buff[0]=0;
	return -1;
}
